Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/read_pstoke.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/read_pstoke.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/read_pstoke.F	(revision 633)
@@ -7,5 +7,14 @@
      .   zrec,zklono,zklevo,airefi,phisfi,
      .   t,mfu,mfd,en_u,de_u,en_d,de_d,coefh,
+     .   fm_therm,en_therm,
      .   frac_impa,frac_nucl,pyu1,pyv1,ftsol,psrf)
+
+C******************************************************************************
+C  Frederic HOURDIN, Abderrahmane IDELKADI
+C Lecture des parametres physique stockes online necessaires pour
+C recalculer offline le transport de traceurs sur une grille 2x plus fine que 
+C celle online 
+C A FAIRE : une seule routine au lieu de 2 (lectflux, redecoupe)!
+C******************************************************************************
 
 
@@ -26,28 +35,31 @@
 #include "dimphy.h"
 	
-	  integer*4 klono,klevo,imo,jmo
+	  integer klono,klevo,imo,jmo
 	  parameter (imo=iim/2,jmo=(jjm+1)/2)
 	  parameter(klono=(jmo-1)*imo+2,klevo=llm)
-	  REAL*4 phisfi(klono)
-          REAL*4 phisfi2(imo,jmo+1),airefi2(imo,jmo+1)
-
-          REAL*4 mfu(klono,klevo), mfd(klono,klevo)
-          REAL*4 en_u(klono,klevo), de_u(klono,klevo)
-          REAL*4 en_d(klono,klevo), de_d(klono,klevo)
-          REAL*4 coefh(klono,klevo)
-
-          REAL*4 mfu2(imo,jmo+1,klevo), mfd2(imo,jmo+1,klevo)
-          REAL*4 en_u2(imo,jmo+1,klevo), de_u2(imo,jmo+1,klevo)
-          REAL*4 en_d2(imo,jmo+1,klevo), de_d2(imo,jmo+1,klevo)
-          REAL*4 coefh2(imo,jmo+1,klevo)
-
-          REAL*4 pl(klevo)
+	  REAL phisfi(klono)
+          REAL phisfi2(imo,jmo+1),airefi2(imo,jmo+1)
+
+          REAL mfu(klono,klevo), mfd(klono,klevo)
+          REAL en_u(klono,klevo), de_u(klono,klevo)
+          REAL en_d(klono,klevo), de_d(klono,klevo)
+          REAL coefh(klono,klevo)
+           REAL fm_therm(klono,klevo),en_therm(klono,klevo)
+
+          REAL mfu2(imo,jmo+1,klevo), mfd2(imo,jmo+1,klevo)
+          REAL en_u2(imo,jmo+1,klevo), de_u2(imo,jmo+1,klevo)
+          REAL en_d2(imo,jmo+1,klevo), de_d2(imo,jmo+1,klevo)
+          REAL coefh2(imo,jmo+1,klevo)
+           REAL fm_therm2(imo,jmo+1,klevo)
+           REAL en_therm2(imo,jmo+1,klevo)
+
+          REAL pl(klevo)
           integer irec
-          integer*4 xid,yid,zid,tid
+          integer xid,yid,zid,tid
           real zrec,zklono,zklevo,zim,zjm
-          integer*4 ncrec,ncklono,ncklevo,ncim,ncjm
-
-          real*4 airefi(klono)
-          character namedim
+          integer ncrec,ncklono,ncklevo,ncim,ncjm
+
+          real airefi(klono)
+          character*20 namedim
 
 c  !! attention !!
@@ -56,20 +68,20 @@
 	  
 	 
-          REAL*4 frac_impa(klono,klevo), frac_nucl(klono,klevo)
-          REAL*4 frac_impa2(imo,jmo+1,klevo), 
+          REAL frac_impa(klono,klevo), frac_nucl(klono,klevo)
+          REAL frac_impa2(imo,jmo+1,klevo), 
      .     frac_nucl2(imo,jmo+1,klevo)
-          REAL*4 pyu1(klono), pyv1(klono)
-          REAL*4 pyu12(imo,jmo+1), pyv12(imo,jmo+1)
-          REAL*4 ftsol(klono,nbsrf)
-          REAL*4 psrf(klono,nbsrf) 
-	  REAL*4 ftsol1(klono),ftsol2(klono),ftsol3(klono),ftsol4(klono)
-          REAL*4 psrf1(klono),psrf2(klono),psrf3(klono),psrf4(klono)
-          REAL*4 ftsol12(imo,jmo+1),ftsol22(imo,jmo+1),
+          REAL pyu1(klono), pyv1(klono)
+          REAL pyu12(imo,jmo+1), pyv12(imo,jmo+1)
+          REAL ftsol(klono,nbsrf)
+          REAL psrf(klono,nbsrf) 
+	  REAL ftsol1(klono),ftsol2(klono),ftsol3(klono),ftsol4(klono)
+          REAL psrf1(klono),psrf2(klono),psrf3(klono),psrf4(klono)
+          REAL ftsol12(imo,jmo+1),ftsol22(imo,jmo+1),
      .     ftsol32(imo,jmo+1),
      .     ftsol42(imo,jmo+1)
-          REAL*4 psrf12(imo,jmo+1),psrf22(imo,jmo+1),psrf32(imo,jmo+1),
+          REAL psrf12(imo,jmo+1),psrf22(imo,jmo+1),psrf32(imo,jmo+1),
      .     psrf42(imo,jmo+1)
-		REAL*4 t(klono,klevo)
-		REAL*4 t2(imo,jmo+1)	
+		REAL t(klono,klevo)
+		REAL t2(imo,jmo+1,klevo)	
 	  integer ncidp
           save ncidp
@@ -77,4 +89,5 @@
           integer varidmfu, varidmfd, varidps, varidenu, variddeu	
           integer varidend,varidded,varidch,varidfi,varidfn
+           integer varidfmth,varidenth
           integer varidyu1,varidyv1,varidpl,varidai,varididvt
           integer varidfts1,varidfts2,varidfts3,varidfts4
@@ -82,4 +95,5 @@
           save varidmfu, varidmfd, varidps, varidenu, variddeu
           save varidend,varidded,varidch,varidfi,varidfn
+           save varidfmth,varidenth
           save varidyu1,varidyv1,varidpl,varidai,varididvt
           save varidfts1,varidfts2,varidfts3,varidfts4
@@ -113,6 +127,8 @@
             print*,'ncidp,varidai',ncidp,varidai
 
+c A FAIRE: Es-il necessaire de stocke t?
 	        varidt=NCVID(ncidp,'t',rcode)
                 print*,'ncidp,varidt',ncidp,varidt
+
             varidmfu=NCVID(ncidp,'mfu',rcode)
             print*,'ncidp,varidmfu',ncidp,varidmfu
@@ -136,4 +152,11 @@
             print*,'ncidp,varidch',ncidp,varidch
 	
+c abder (pour thermiques)
+             varidfmth=NCVID(ncidp,'fm_th',rcode)
+             print*,'ncidp,varidfmth',ncidp,varidfmth
+
+             varidenth=NCVID(ncidp,'en_th',rcode)
+             print*,'ncidp,varidenth',ncidp,varidenth
+
 	    varidfi=NCVID(ncidp,'frac_impa',rcode)
             print*,'ncidp,varidfi',ncidp,varidfi
@@ -200,6 +223,9 @@
 
 c niveaux de pression
-
-            status=NF_GET_VARA_REAL(ncidp,varidpl,1,zklevo,pl)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpl,1,zklevo,pl)
+#else
+      status=NF_GET_VARA_REAL(ncidp,varidpl,1,zklevo,pl)
+#endif
 
 c lecture de aire et phis
@@ -216,15 +242,17 @@
 
 c phis
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidps,start,count,phisfi2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidps,start,count,phisfi2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,phisfi2)
-c      call dump2d(iip1-1,jjp1,phisfi2,'PHISNC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,phisfi2,phisfi)
 
 c aire
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidai,start,count,airefi2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidai,start,count,airefi2)
-c      call correctbid(iim,jjp1*1,airefi2)
-c       call dump2d(iip1-1,jjp1,airefi2,'AIRENC')
+#endif
        call gr_ecrit_fi(1,klono,imo,jmo+1,airefi2,airefi)
       else
@@ -249,165 +277,190 @@
       count(4)=1
 
+
+C *** Lessivage******************************************************
 c frac_impa 
-
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfi,start,count,frac_impa2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfi,start,count,frac_impa2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,frac_impa2)
-c      call dump2d(iip1-1,jjp1,frac_impa2,'FINC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,frac_impa2,frac_impa)
 
 c frac_nucl 
-
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfn,start,count,frac_nucl2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfn,start,count,frac_nucl2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,frac_nucl2)
-c      call dump2d(iip1-1,jjp1,frac_nucl2,'FINC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,frac_nucl2,frac_nucl)
 
+C*** Temperature ******************************************************
 c abder t
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidt,start,count,t2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidt,start,count,t2)
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,t2,t)
 
+C*** Flux pour le calcul de la convection TIEDTK ***********************
 c mfu
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidmfu,start,count,mfu2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidmfu,start,count,mfu2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,mfu2)
-c      call dump2d(iip1-1,jjp1,mfu2,'MFUNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,mfu2,mfu)
 
 c mfd
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidmfd,start,count,mfd2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidmfd,start,count,mfd2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,mfd2)
-c      call dump2d(iip1-1,jjp1,mfd2,'MFDNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,mfd2,mfd)
 
 c en_u 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidenu,start,count,en_u2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidenu,start,count,en_u2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,en_u2)
-c      call dump2d(iip1-1,jjp1,en_u2,'ENUNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,en_u2,en_u)
 
 c de_u 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,variddeu,start,count,de_u2)
+#else
       status=NF_GET_VARA_REAL(ncidp,variddeu,start,count,de_u2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,de_u2)
-c      call dump2d(iip1-1,jjp1,de_u2,'DEUNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,de_u2,de_u)
 
 c en_d 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidend,start,count,en_d2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidend,start,count,en_d2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,en_d2)
-c      call dump2d(iip1-1,jjp1,en_d2,'ENDNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,en_d2,en_d)
 
 c de_d 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidded,start,count,de_d2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidded,start,count,de_d2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,de_d2)
-c      call dump2d(iip1-1,jjp1,de_d2,'DEDNC COUCHE 1')
+#endif
       call gr_ecrit_fi(klevo,klono,imo,jmo+1,de_d2,de_d)
 
+C **** Coeffecient du mellange turbulent**********************************
 c coefh 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidch,start,count,coefh2)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidch,start,count,coefh2)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*klevo,coefh2)
-c      call dump2d(iip1-1,jjp1,coefh2,'CHNC COUCHE 1')
+#endif
        call gr_ecrit_fi(klevo,klono,imo,jmo+1,coefh2,coefh)
 
+C*** Flux ascendant et entrant pour les Thermiques************************
+cabder thermiques
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfmth,start,count,fm_therm2)
+#else
+      status=NF_GET_VARA_REAL(ncidp,varidfmth,start,count,fm_therm2)
+#endif
+      call gr_ecrit_fi(klevo,klono,imo,jmo+1,fm_therm2,fm_therm)
+
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidenth,start,count,en_therm2)
+#else
+      status=NF_GET_VARA_REAL(ncidp,varidenth,start,count,en_therm2)
+#endif
+      call gr_ecrit_fi(klevo,klono,imo,jmo+1,en_therm2,en_therm)
+
+C*** Vitesses aux sol ******************************************************
       start(3)=irec
       start(4)=0
       count(3)=1
       count(4)=0
-
 c pyu1
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidyu1,start,count,pyu12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidyu1,start,count,pyu12)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,pyu12)
-c      call dump2d(iip1-1,jjp1,pyu12,'PYU1NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,pyu12,pyu1)
 
 c pyv1
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidyv1,start,count,pyv12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidyv1,start,count,pyv12)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,pyv12)
-c      call dump2d(iip1-1,jjp1,pyv12,'PYV1NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,pyv12,pyv1)
 
+C*** Temperature au sol ********************************************
 c ftsol1
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts1,start,count,ftsol12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts1,start,count,ftsol12)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,ftsol12)
-c      call dump2d(iip1-1,jjp1,ftsol12,'FTS1NC')
+#endif
        call gr_ecrit_fi(1,klono,imo,jmo+1,ftsol12,ftsol1)
 
 c ftsol2
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts2,start,count,ftsol22)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts2,start,count,ftsol22)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,ftsol22)
-c      call dump2d(iip1-1,jjp1,ftsol22,'FTS2NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,ftsol22,ftsol2)
 
 c ftsol3
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts3,start,count,ftsol32)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts3,start,count,ftsol32)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,ftsol32)
-c      call dump2d(iip1-1,jjp1,ftsol32,'FTS3NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,ftsol32,ftsol3)
 
 c ftsol4
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts4,start,count,ftsol42)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts4,start,count,ftsol42)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,ftsol42)
-c      call dump2d(iip1-1,jjp1,ftsol42,'FTS4NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,ftsol42,ftsol4)
 
+C*** Nature du sol **************************************************
 c psrf1 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr1,start,count,psrf12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr1,start,count,psrf12)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,psrf12)
-c      call dump2d(iip1-1,jjp1,psrf12,'PSRF1NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,psrf12,psrf1)
 
 c psrf2 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr2,start,count,psrf22)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr2,start,count,psrf22)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,psrf22)
-c      call dump2d(iip1-1,jjp1,psrf22,'PSRF2NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,psrf22,psrf2)
 
 c psrf3 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr3,start,count,psrf32)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr3,start,count,psrf32)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,psrf32)
-c      call dump2d(iip1-1,jjp1,psrf32,'PSRF3NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,psrf32,psrf3)
 
 c psrf4 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr4,start,count,psrf42)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr4,start,count,psrf42)
-c      print*,'WARNING!!! Correction bidon pour palier a un '
-c      print*,'probleme dans la creation des fichiers nc'
-c      call correctbid(iim,jjp1*1,psrf42)
-c      call dump2d(iip1-1,jjp1,psrf42,'PSRF4NC')
+#endif
       call gr_ecrit_fi(1,klono,imo,jmo+1,psrf42,psrf4)
 	
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/read_pstoke0.F
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/read_pstoke0.F	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/read_pstoke0.F	(revision 633)
@@ -7,5 +7,13 @@
      .   zrec,zkon,zkev,airefi,phisfi,
      .   t,mfu,mfd,en_u,de_u,en_d,de_d,coefh,
+     .   fm_therm,en_therm,
      .   frac_impa,frac_nucl,pyu1,pyv1,ftsol,psrf)
+
+C******************************************************************************
+C  Frederic HOURDIN, Abderrahmane IDELKADI
+C Lecture des parametres physique stockes online necessaires pour
+C recalculer offline le transport des traceurs sur la meme grille que online
+C A FAIRE : une seule routine au lieu de 2 (lectflux, redecoupe)!
+C******************************************************************************
 
 
@@ -26,29 +34,36 @@
 #include "dimphy.h"
 	  
-	  integer*4 kon,kev,zkon,zkev
+	  integer kon,kev,zkon,zkev
 	  parameter(kon=iim*(jjm-1)+2,kev=llm)
-	  REAL*4 phisfi(kon)
-          REAL*4 phisfi2(iim,jjm+1),airefi2(iim,jjm+1)
-
-          REAL*4 mfu(kon,kev), mfd(kon,kev)
-          REAL*4 en_u(kon,kev), de_u(kon,kev)
-          REAL*4 en_d(kon,kev), de_d(kon,kev)
-          REAL*4 coefh(kon,kev)
-		REAL*4 t(kon,kev)
-
-          REAL*4 mfu2(iim,jjm+1,kev), mfd2(iim,jjm+1,kev)
-          REAL*4 en_u2(iim,jjm+1,kev), de_u2(iim,jjm+1,kev)
-          REAL*4 en_d2(iim,jjm+1,kev), de_d2(iim,jjm+1,kev)
-          REAL*4 coefh2(iim,jjm+1,kev)
-		REAL*4 t2(iim,jjm+1,kev)
-
-          REAL*4 pl(kev)
+	  REAL phisfi(kon)
+          REAL phisfi2(iim,jjm+1),airefi2(iim,jjm+1)
+
+          REAL mfu(kon,kev), mfd(kon,kev)
+          REAL en_u(kon,kev), de_u(kon,kev)
+          REAL en_d(kon,kev), de_d(kon,kev)
+          REAL coefh(kon,kev)
+
+c abd 25 11 02
+c Thermiques
+	 REAL fm_therm(kon,kev),en_therm(kon,kev)
+		REAL t(kon,kev)
+
+          REAL mfu2(iim,jjm+1,kev), mfd2(iim,jjm+1,kev)
+          REAL en_u2(iim,jjm+1,kev), de_u2(iim,jjm+1,kev)
+          REAL en_d2(iim,jjm+1,kev), de_d2(iim,jjm+1,kev)
+          REAL coefh2(iim,jjm+1,kev)
+		REAL t2(iim,jjm+1,kev)
+c Thermiques
+	 REAL fm_therm2(iim,jjm+1,kev)
+         REAL en_therm2(iim,jjm+1,kev)       
+
+          REAL pl(kev)
           integer irec
-          integer*4 xid,yid,zid,tid
-          integer*4 zrec,zim,zjm
-          integer*4 ncrec,nckon,nckev,ncim,ncjm
-
-          real*4 airefi(kon)
-          character namedim
+          integer xid,yid,zid,tid
+          integer zrec,zim,zjm
+          integer ncrec,nckon,nckev,ncim,ncjm
+
+          real airefi(kon)
+          character*20 namedim
 
 c  !! attention !!
@@ -56,17 +71,17 @@
 c dim de phis??
 
-          REAL*4 frac_impa(kon,kev), frac_nucl(kon,kev)
-          REAL*4 frac_impa2(iim,jjm+1,kev), 
+          REAL frac_impa(kon,kev), frac_nucl(kon,kev)
+          REAL frac_impa2(iim,jjm+1,kev), 
      .     frac_nucl2(iim,jjm+1,kev)
-          REAL*4 pyu1(kon), pyv1(kon)
-          REAL*4 pyu12(iim,jjm+1), pyv12(iim,jjm+1)
-          REAL*4 ftsol(kon,nbsrf)
-          REAL*4 psrf(kon,nbsrf) 
-	  REAL*4 ftsol1(kon),ftsol2(kon),ftsol3(kon),ftsol4(kon)
-          REAL*4 psrf1(kon),psrf2(kon),psrf3(kon),psrf4(kon)
-          REAL*4 ftsol12(iim,jjm+1),ftsol22(iim,jjm+1),
+          REAL pyu1(kon), pyv1(kon)
+          REAL pyu12(iim,jjm+1), pyv12(iim,jjm+1)
+          REAL ftsol(kon,nbsrf)
+          REAL psrf(kon,nbsrf) 
+	  REAL ftsol1(kon),ftsol2(kon),ftsol3(kon),ftsol4(kon)
+          REAL psrf1(kon),psrf2(kon),psrf3(kon),psrf4(kon)
+          REAL ftsol12(iim,jjm+1),ftsol22(iim,jjm+1),
      .     ftsol32(iim,jjm+1),
      .     ftsol42(iim,jjm+1)
-          REAL*4 psrf12(iim,jjm+1),psrf22(iim,jjm+1),psrf32(iim,jjm+1),
+          REAL psrf12(iim,jjm+1),psrf22(iim,jjm+1),psrf32(iim,jjm+1),
      .     psrf42(iim,jjm+1)
 	
@@ -76,4 +91,6 @@
 		integer varidt
           integer varidend,varidded,varidch,varidfi,varidfn
+c therm
+	  integer varidfmth,varidenth
           integer varidyu1,varidyv1,varidpl,varidai,varididvt
           integer varidfts1,varidfts2,varidfts3,varidfts4
@@ -82,4 +99,6 @@
 		save varidt
           save varidend,varidded,varidch,varidfi,varidfn
+c therm
+	   save varidfmth,varidenth
           save varidyu1,varidyv1,varidpl,varidai,varididvt
           save varidfts1,varidfts2,varidfts3,varidfts4
@@ -112,10 +131,10 @@
             print*,'ncidp,varidai',ncidp,varidai
 
+                varidt=NCVID(ncidp,'t',rcode)
+                print*,'ncidp,varidt',ncidp,varidt
+
             varidmfu=NCVID(ncidp,'mfu',rcode)
             print*,'ncidp,varidmfu',ncidp,varidmfu
 
-		varidt=NCVID(ncidp,'t',rcode)
-                print*,'ncidp,varidt',ncidp,varidt
-
             varidmfd=NCVID(ncidp,'mfd',rcode)
             print*,'ncidp,varidmfd',ncidp,varidmfd
@@ -135,4 +154,11 @@
             varidch=NCVID(ncidp,'coefh',rcode)
             print*,'ncidp,varidch',ncidp,varidch
+
+c Thermiques
+            varidfmth=NCVID(ncidp,'fm_th',rcode)
+            print*,'ncidp,varidfmth',ncidp,varidfmth
+
+            varidenth=NCVID(ncidp,'en_th',rcode)
+            print*,'ncidp,varidenth',ncidp,varidenth
 	
 	    varidfi=NCVID(ncidp,'frac_impa',rcode)
@@ -216,10 +242,20 @@
 
 c 
+C**** Geopotentiel au sol ***************************************
 c phis
-      status=NF_GET_VARA_REAL(ncidp,varidps,start,count,phisfi2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidps,start,count,phisfi2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidps,start,count,phisfi2)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,phisfi2,phisfi)
 
+C**** Aires des mails aux sol ************************************
 c aire
-      status=NF_GET_VARA_REAL(ncidp,varidai,start,count,airefi2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidai,start,count,airefi2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidai,start,count,airefi2)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,airefi2,airefi)
       else
@@ -244,46 +280,116 @@
       count(4)=1
 
-c frac_impa 
-
-      status=NF_GET_VARA_REAL(ncidp,varidfi,start,count,frac_impa2)
-      call gr_ecrit_fi(kev,kon,iim,jjm+1,frac_impa2,frac_impa)
-
-c frac_nucl 
-
-      status=NF_GET_VARA_REAL(ncidp,varidfn,start,count,frac_nucl2)
-      call gr_ecrit_fi(kev,kon,iim,jjm+1,frac_nucl2,frac_nucl)
+C**** Temperature ********************************************
+cA FAIRE : Es-ce necessaire ?
 
 c abder t
-      status=NF_GET_VARA_REAL(ncidp,varidt,start,count,t2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidt,start,count,t2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidt,start,count,t2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,t2,t)
 
+C**** Flux pour la convection (Tiedtk) ********************************************
 c mfu
-      status=NF_GET_VARA_REAL(ncidp,varidmfu,start,count,mfu2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidmfu,start,count,mfu2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidmfu,start,count,mfu2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,mfu2,mfu)
 
 c mfd
-      status=NF_GET_VARA_REAL(ncidp,varidmfd,start,count,mfd2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidmfd,start,count,mfd2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidmfd,start,count,mfd2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,mfd2,mfd)
 
 c en_u 
-      status=NF_GET_VARA_REAL(ncidp,varidenu,start,count,en_u2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidenu,start,count,en_u2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidenu,start,count,en_u2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,en_u2,en_u)
 
 c de_u 
-      status=NF_GET_VARA_REAL(ncidp,variddeu,start,count,de_u2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,variddeu,start,count,de_u2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,variddeu,start,count,de_u2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,de_u2,de_u)
 
 c en_d 
-      status=NF_GET_VARA_REAL(ncidp,varidend,start,count,en_d2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidend,start,count,en_d2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidend,start,count,en_d2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,en_d2,en_d)
 
 c de_d 
-      status=NF_GET_VARA_REAL(ncidp,varidded,start,count,de_d2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidded,start,count,de_d2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidded,start,count,de_d2)
+#endif
       call gr_ecrit_fi(kev,kon,iim,jjm+1,de_d2,de_d)
 
+C**** Coefficient de mellange turbulent *******************************************
 c coefh 
 	print*,'LECTURE de coefh a irec =',irec
-       status=NF_GET_VARA_REAL(ncidp,varidch,start,count,coefh2)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidch,start,count,coefh2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidch,start,count,coefh2)
+#endif
        call gr_ecrit_fi(kev,kon,iim,jjm+1,coefh2,coefh)
+c      call dump2d(iip1,jjp1,coefh2(1,2),'COEFH2READ   ')
+c      call dump2d(iim ,jjm ,coefh (2,2),'COEFH2READ   ')
+
+C**** Flux ascendants et entrant dans le thermique **********************************
+cThermiques
+       print*,'LECTURE de fm_therm a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfmth,start,
+     .                         count,fm_therm2)
+#else
+       status=NF_GET_VARA_REAL(ncidp,varidfmth,start,
+     .                         count,fm_therm2)
+#endif
+       call gr_ecrit_fi(kev,kon,iim,jjm+1,fm_therm2,fm_therm)
+       print*,'LECTURE de en_therm a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidenth,start,
+     .                          count,en_therm2)
+#else
+       status=NF_GET_VARA_REAL(ncidp,varidenth,start,
+     .                          count,en_therm2)
+#endif
+       call gr_ecrit_fi(kev,kon,iim,jjm+1,en_therm2,en_therm)
+
+C**** Coefficients de lessivage *******************************************
+c frac_impa
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfi,start,count,frac_impa2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidfi,start,count,frac_impa2)
+#endif
+      call gr_ecrit_fi(kev,kon,iim,jjm+1,frac_impa2,frac_impa)
+
+c frac_nucl
+
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfn,start,count,frac_nucl2)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidfn,start,count,frac_nucl2)
+#endif
+      call gr_ecrit_fi(kev,kon,iim,jjm+1,frac_nucl2,frac_nucl)
+
+C**** Vents aux sol ********************************************
 
       start(3)=irec
@@ -294,47 +400,89 @@
 c pyu1
 	print*,'LECTURE de yu1 a irec =',irec
-      status=NF_GET_VARA_REAL(ncidp,varidyu1,start,count,pyu12)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidyu1,start,count,pyu12)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidyu1,start,count,pyu12)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,pyu12,pyu1)
 
 c pyv1
         print*,'LECTURE de yv1 a irec =',irec
-      status=NF_GET_VARA_REAL(ncidp,varidyv1,start,count,pyv12)
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidyv1,start,count,pyv12)
+#else
+        status=NF_GET_VARA_REAL(ncidp,varidyv1,start,count,pyv12)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,pyv12,pyv1)
 
+C**** Temerature au sol ********************************************
 c ftsol1
         print*,'LECTURE de ftsol1 a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts1,start,count,ftsol12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts1,start,count,ftsol12)
+#endif
        call gr_ecrit_fi(1,kon,iim,jjm+1,ftsol12,ftsol1)
 
 c ftsol2
         print*,'LECTURE de ftsol2 a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts2,start,count,ftsol22)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts2,start,count,ftsol22)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,ftsol22,ftsol2)
 
 c ftsol3
 	 print*,'LECTURE de ftsol3 a irec =',irec
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts3,start,count,ftsol32)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts3,start,count,ftsol32)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,ftsol32,ftsol3)
 
 c ftsol4
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidfts4,start,count,ftsol42)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidfts4,start,count,ftsol42)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,ftsol42,ftsol4)
 
+C**** Nature sol ********************************************
 c psrf1 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr1,start,count,psrf12)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr1,start,count,psrf12)
+#endif
 c      call dump2d(iip1-1,jjm+1,psrf12,'PSRF1NC')
       call gr_ecrit_fi(1,kon,iim,jjm+1,psrf12,psrf1)
 
 c psrf2 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr2,start,count,psrf22)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr2,start,count,psrf22)
+#endif
 c      call dump2d(iip1-1,jjm+1,psrf22,'PSRF2NC')
       call gr_ecrit_fi(1,kon,iim,jjm+1,psrf22,psrf2)
 
 c psrf3 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr3,start,count,psrf32)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr3,start,count,psrf32)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,psrf32,psrf3)
 
 c psrf4 
+#ifdef NC_DOUBLE
+      status=NF_GET_VARA_DOUBLE(ncidp,varidpsr4,start,count,psrf42)
+#else
       status=NF_GET_VARA_REAL(ncidp,varidpsr4,start,count,psrf42)
+#endif
       call gr_ecrit_fi(1,kon,iim,jjm+1,psrf42,psrf4)
 	
@@ -344,4 +492,6 @@
         psrf(i,2) = psrf2(i)
         psrf(i,3) = psrf3(i)
+c test abderr
+c	print*,'Dans read_pstoke psrf3 =',psrf3(i),i
         psrf(i,4) = psrf4(i)
   
Index: LMDZ4/branches/LMDZ4_par_0/libf/phylmd/stdlevvar.F90
===================================================================
--- LMDZ4/branches/unlabeled-1.1.1/libf/phylmd/stdlevvar.F90	(revision 547)
+++ LMDZ4/branches/LMDZ4_par_0/libf/phylmd/stdlevvar.F90	(revision 633)
@@ -101,6 +101,10 @@
         ustar(i) = sqrt(cdram(i) * speed(i) * speed(i))
         zdte(i) = tpot(i) - ts1(i)
+!       PRINT*,'AVANT i,zdte',i,zdte(i)
 !IM cf FH : on prend le max : pour eviter le plantage sur SUN
-        zdte(i) = max(zdte(i),1.e-10)
+!IM BUG BUG BUG       zdte(i) = max(zdte(i),1.e-10)
+        zdte(i) = sign(max(abs(zdte(i)),1.e-10),zdte(i))
+!       PRINT*,'APRES i,zdte',i,zdte(i)
+!
         zdq(i) = max(q1(i),0.0) - max(qsurf(i),0.0)
 !
